/* Automatically generated from Squeak on #(27 June 2004 9:42:34 pm) */

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

/* Default EXPORT macro that does nothing (see comment in sq.h): */
#define EXPORT(returnType) returnType

/* Do not include the entire sq.h file but just those parts needed. */
/*  The virtual machine proxy definition */
#include "sqVirtualMachine.h"
/* Configuration options */
#include "sqConfig.h"
/* Platform specific definitions */
#include "sqPlatformSpecific.h"

#define true 1
#define false 0
#define null 0  /* using 'null' because nil is predefined in Think C */
#ifdef SQUEAK_BUILTIN_PLUGIN
#undef EXPORT
// was #undef EXPORT(returnType) but screws NorCroft cc
#define EXPORT(returnType) static returnType
#endif
#include "V4LPlugin.h"

/* memory access macros */
#define byteAt(i) (*((unsigned char *) (i)))
#define byteAtput(i, val) (*((unsigned char *) (i)) = val)
#define longAt(i) (*((int *) (i)))
#define longAtput(i, val) (*((int *) (i)) = val)


/*** Variables ***/

#ifdef SQUEAK_BUILTIN_PLUGIN
extern
#endif
struct VirtualMachine* interpreterProxy;
static const char *moduleName =
#ifdef SQUEAK_BUILTIN_PLUGIN
	"V4LPlugin 27 June 2004 (i)"
#else
	"V4LPlugin 27 June 2004 (e)"
#endif
;

/*** Function Prototypes ***/
static char* buffer32(Camera camera);
static int createCameraOnwidthheightdepthpallete(char* deviceName, int width, int height, int depth, int palette);
static int depth(Camera camera);
#pragma export on
EXPORT(const char*) getModuleName(void);
#pragma export off
static int halt(void);
static int height(Camera camera);
static int msg(char *s);
static int palette(Camera camera);
#pragma export on
EXPORT(int) primitiveCameraClose(void);
EXPORT(int) primitiveCameraCreate(void);
EXPORT(int) primitiveCameraDepth(void);
EXPORT(int) primitiveCameraHeight(void);
EXPORT(int) primitiveCameraNextFrameInto(void);
EXPORT(int) primitiveCameraPalette(void);
EXPORT(int) primitiveCameraWidth(void);
EXPORT(int) setInterpreter(struct VirtualMachine* anInterpreter);
#pragma export off
static int width(Camera camera);

static char* buffer32(Camera camera) {
	return camera->buffer32;
}

static int createCameraOnwidthheightdepthpallete(char* deviceName, int width, int height, int depth, int palette) {
	return (int) createCamera(deviceName, width, height, depth, palette);
}

static int depth(Camera camera) {
	return camera->vpicture.depth;
}


/*	Note: This is hardcoded so it can be run from Squeak.
	The module name is used for validating a module *after*
	it is loaded to check if it does really contain the module
	we're thinking it contains. This is important! */

EXPORT(const char*) getModuleName(void) {
	return moduleName;
}

static int halt(void) {
	;
}

static int height(Camera camera) {
	return camera->vwindow.height;
}

static int msg(char *s) {
	fprintf(stderr, "\n%s: %s", moduleName, s);
}

static int palette(Camera camera) {
	return camera->vpicture.palette;
}

EXPORT(int) primitiveCameraClose(void) {
    Camera camera;

	camera = ((Camera) (interpreterProxy->stackIntegerValue(0)));
	closeCamera(camera);
	interpreterProxy->pop(1);
}

EXPORT(int) primitiveCameraCreate(void) {
    int height;
    int depth;
    int deviceNamePointer;
    char deviceName[1024];
    int width;
    int deviceNameSize;
    int cameraPointer;
    int palette;
    char * deviceNameIndex;

	palette = interpreterProxy->stackIntegerValue(0);
	depth = interpreterProxy->stackIntegerValue(1);
	height = interpreterProxy->stackIntegerValue(2);
	width = interpreterProxy->stackIntegerValue(3);
	deviceNamePointer = interpreterProxy->stackValue(4);
	if (!(interpreterProxy->isBytes(deviceNamePointer))) {
		return interpreterProxy->primitiveFail();
	}
	deviceNameIndex = interpreterProxy->firstIndexableField(deviceNamePointer);

	/*  */

	deviceNameSize = interpreterProxy->byteSizeOf(deviceNamePointer);
	/* dummy in C */;
	strncpy(deviceName, deviceNameIndex, deviceNameSize);
	deviceName[deviceNameSize] = 0;

	/*  */

	cameraPointer = createCameraOnwidthheightdepthpallete(deviceName, width, height, depth, palette);
	if (cameraPointer == 0) {
		return interpreterProxy->primitiveFail();
	}
	interpreterProxy->popthenPush(6, ((cameraPointer << 1) | 1));
}

EXPORT(int) primitiveCameraDepth(void) {
    int d;
    Camera camera;

	camera = ((Camera) (interpreterProxy->stackIntegerValue(0)));
	d = depth(camera);
	interpreterProxy->popthenPush(2, ((d << 1) | 1));
}

EXPORT(int) primitiveCameraHeight(void) {
    Camera camera;
    int h;

	camera = ((Camera) (interpreterProxy->stackIntegerValue(0)));
	h = height(camera);
	interpreterProxy->popthenPush(2, ((h << 1) | 1));
}


/*	set the capture extent and pixel format to use */

EXPORT(int) primitiveCameraNextFrameInto(void) {
    int arraySize;
    Camera camera;
    unsigned char* dest;
    unsigned char* final;
    unsigned char* src;
    int imageSize;
    int arrayPointer;
    int result;

	arrayPointer = interpreterProxy->stackValue(0);
	interpreterProxy->success(!(interpreterProxy->isPointers(arrayPointer)));
	if (interpreterProxy->failed()) {
		return null;
	}

	/*  */

	arraySize = interpreterProxy->byteSizeOf(arrayPointer);

	/*  */

	camera = ((Camera) (interpreterProxy->stackIntegerValue(1)));
	result = nextFrameFromCamera(camera);
	if (!(result)) {
		return interpreterProxy->primitiveFail();
	}
	imageSize = (width(camera)) * (height(camera));
	dest = ((unsigned char*) (arrayPointer + 4));
	src = buffer32(camera);

	/*  */

	final = dest + ((((imageSize * 4) < arraySize) ? arraySize : (imageSize * 4)));
	while (dest < final) {
		dest[0] = (src[2]);
		dest[1] = (src[1]);
		dest[2] = (src[0]);
		dest[3] = (src[3]);
		dest += 4;
		src += 4;
	}
	interpreterProxy->pop(2);
}

EXPORT(int) primitiveCameraPalette(void) {
    Camera camera;
    int p;

	camera = ((Camera) (interpreterProxy->stackIntegerValue(0)));
	p = palette(camera);
	interpreterProxy->popthenPush(2, ((p << 1) | 1));
}

EXPORT(int) primitiveCameraWidth(void) {
    Camera camera;
    int w;

	camera = ((Camera) (interpreterProxy->stackIntegerValue(0)));
	w = width(camera);
	interpreterProxy->popthenPush(2, ((w << 1) | 1));
}


/*	Note: This is coded so that is can be run from Squeak. */

EXPORT(int) setInterpreter(struct VirtualMachine* anInterpreter) {
    int ok;

	interpreterProxy = anInterpreter;
	ok = interpreterProxy->majorVersion() == VM_PROXY_MAJOR;
	if (ok == 0) {
		return 0;
	}
	ok = interpreterProxy->minorVersion() >= VM_PROXY_MINOR;
	return ok;
}

static int width(Camera camera) {
	return camera->vwindow.width;
}


#ifdef SQUEAK_BUILTIN_PLUGIN


void* V4LPlugin_exports[][3] = {
	{"V4LPlugin", "primitiveCameraCreate", (void*)primitiveCameraCreate},
	{"V4LPlugin", "primitiveCameraClose", (void*)primitiveCameraClose},
	{"V4LPlugin", "primitiveCameraNextFrameInto", (void*)primitiveCameraNextFrameInto},
	{"V4LPlugin", "primitiveCameraWidth", (void*)primitiveCameraWidth},
	{"V4LPlugin", "primitiveCameraPalette", (void*)primitiveCameraPalette},
	{"V4LPlugin", "primitiveCameraHeight", (void*)primitiveCameraHeight},
	{"V4LPlugin", "primitiveCameraDepth", (void*)primitiveCameraDepth},
	{"V4LPlugin", "getModuleName", (void*)getModuleName},
	{"V4LPlugin", "setInterpreter", (void*)setInterpreter},
	{NULL, NULL, NULL}
};


#endif /* ifdef SQ_BUILTIN_PLUGIN */

