#ifndef _VIDEOLIB_H
#define _VIDEOLIB_H

#include <linux/videodev.h>

//enum bool {false, true};

//typedef enum bool boolean;
typedef int BOOLEAN;
#define TRUE 1
#define FALSE 0


struct cam {
   char* deviceName;

   int width;
   int height;

   int depth;
   int palette;

   int fd;

   struct video_capability vcapability;
   struct video_window     vwindow;
   struct video_picture    vpicture;

   char *buffer;

   struct video_mbuf memoryBuffer;
   char* memoryMap;
   struct video_mmap* mmaps;
   int imageSize;
   int bufferIndex;
   char *buffer32;

   BOOLEAN forceRead;
   BOOLEAN usingMMap;
};

typedef struct cam* Camera;

#define SIZE_OF_CAMERA sizeof(struct cam)



/* Camera createCamera(char* deviceName, */
/*                     int width, int height, */
/*                     int depth, int palette); */
/* BOOLEAN openCamera(Camera camera); */
Camera createCamera(char* deviceName,
                    int width, int height,
                    int depth, int palette);

BOOLEAN nextFrameFromCamera(Camera camera);

/* void    closeCamera(Camera camera); */
/* void    destroyCamera(Camera camera); */
void    closeCamera(Camera camera);


void savePPM(char* fileName, Camera camera);

#endif
